using Microsoft.AspNetCore.Authentication.Cookies;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using MySql.Data.MySqlClient;
using Quartz;
using Quartz.Impl;
using Quartz.Spi;
using SolarPower.Helper;
using SolarPower.Models;
using SolarPower.Quartz;
using SolarPower.Quartz.Jobs;
using SolarPower.Repository.Implement;
using SolarPower.Repository.Interface;
using SolarPower.Services;
using SolarPower.Services.Implement;
using SolarPower.Services.Interface;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading.Tasks;

namespace SolarPower
{
    public class Startup
    {
        public IConfiguration Configuration { get; }
        public DBConfig dBConfig = new DBConfig();

        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;

            dBConfig.Server = Configuration.GetValue<string>("DBConfig:Server");
            dBConfig.Port = Configuration.GetValue<string>("DBConfig:Port");
            dBConfig.Database = Configuration.GetValue<string>("DBConfig:Database");
            dBConfig.Root = Configuration.GetValue<string>("DBConfig:Root");
            dBConfig.Password = Configuration.GetValue<string>("DBConfig:Password");
        }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddControllersWithViews();

            services.AddLogging(
            builder =>
            {
                builder.AddFilter("Microsoft", LogLevel.Warning)
                       .AddFilter("System", LogLevel.Warning)
                       .AddFilter("NToastNotify", LogLevel.Warning)
                       .AddConsole();
            });

            #region SMPT配置
            services.AddTransient<ISendEmailService, SendEmailService>();
            services.Configure<SMTPConfig>(Configuration.GetSection("SMTPConfig"));
            #endregion

            #region DBHelper 注入
            services.AddTransient<IDatabaseHelper>(x => new DatabaseHelper(dBConfig));
            #endregion

            #region Repository 注入
            services.AddTransient<IUserRepository, UserRepository>();
            services.AddTransient<ICompanyRepository, CompanyRepository>();
            services.AddTransient<IRoleRepository, RoleRepository>();
            services.AddTransient<IPowerStationRepository, PowerStationRepository>();
            services.AddTransient<IOperatorLogRepository, OperatorLogRepository>();
            services.AddTransient<IOperationRepository, OperationRepository>();
            services.AddTransient<IOverviewRepository, OverviewRepository>();
            services.AddTransient<IAnalysisStationCombineRepository,AnalysisStationCombineRepository>();
            #endregion

            double loginExpireMinute = this.Configuration.GetValue<double>("LoginExpireMinute");
            services.AddSession(options =>
            {
                options.IdleTimeout = TimeSpan.FromMinutes(loginExpireMinute);
            });

            #region 加入背景執行
            //services.AddHostedService<OperationScheduleBackgroundService>();

            //添加Quartz服務
            services.AddSingleton<IJobFactory, SingletonJobFactory>();
            services.AddSingleton<ISchedulerFactory, StdSchedulerFactory>();
            //添加Job
            #region 定期計畫
            services.AddSingleton<OperationScheduleJob>();
            services.AddSingleton(
                 new JobSchedule(jobType: typeof(OperationScheduleJob), cronExpression: Configuration.GetValue<string>("BackgroundServiceCron:OperationScheduleJob"))
            );
            #endregion

            #region 計算電站逆變器資訊(每整點2分開始執行15分鐘一個循環)
            services.AddSingleton<CalcInverter15minJob>();
            services.AddSingleton(
                 new JobSchedule(jobType: typeof(CalcInverter15minJob), cronExpression: Configuration.GetValue<string>("BackgroundServiceCron:CalcInverter15minJob"))
            );
            #endregion

            #region 計算電站發電量等資訊(每整點5分執行)
            services.AddSingleton<CalcPowerStationJob>();
            services.AddSingleton(
            new JobSchedule(jobType: typeof(CalcPowerStationJob), cronExpression: Configuration.GetValue<string>("BackgroundServiceCron:CalcPowerStationJob"))
            //new JobSchedule(jobType: typeof(CalcPowerStationJob), cronExpression: "0/10 * * * * ?")
            );
            #endregion

            #region 計算電站日照量、PR、kWP 30日平均、(每天凌晨2點執行)
            services.AddSingleton<CalcAvgPowerStationJob>();
            services.AddSingleton(
            new JobSchedule(jobType: typeof(CalcAvgPowerStationJob), cronExpression: Configuration.GetValue<string>("BackgroundServiceCron:CalcAvgPowerStationJob"))
            //new JobSchedule(jobType: typeof(CalcAvgPowerStationJob), cronExpression: "0/10 * * * * ?")
            );
            #endregion
            services.AddHostedService<QuartzHostedService>();
            #endregion
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env, ILoggerFactory loggerFactory)
        {
            loggerFactory.AddFile("Logs/log-{Date}.txt");

            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                app.UseExceptionHandler("/Home/Error");
                // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
                app.UseHsts();
            }

            app.UseSession();
            app.UseHttpsRedirection();
            app.UseStaticFiles();

            app.UseRouting();

            app.UseAuthorization();

            app.UseEndpoints(endpoints =>
            {
                endpoints.MapControllerRoute(
                    name: "default",
                    pattern: "{controller=Login}/{action=Index}/{id?}");
            });
        }
    }
}
